From 6fdd33d5bad629d796aa956a4f1f57aa92897c57 Mon Sep 17 00:00:00 2001
From: Christophe Geuzaine <cgeuzaine@uliege.be>
Date: Thu, 29 Feb 2024 20:28:42 +0000
Subject: [PATCH] Update gmm

---
 contrib/gmm/gmm.h                           |  61 +-
 contrib/gmm/gmm_MUMPS_interface.h           | 313 +++---
 contrib/gmm/gmm_algobase.h                  | 110 ++-
 contrib/gmm/gmm_arch_config.h               |   7 +
 contrib/gmm/gmm_blas.h                      | 585 ++++++------
 contrib/gmm/gmm_blas_interface.h            | 472 +++++++---
 contrib/gmm/gmm_condition_number.h          |  63 +-
 contrib/gmm/gmm_conjugated.h                | 195 ++--
 contrib/gmm/gmm_def.h                       | 121 +--
 contrib/gmm/gmm_dense_Householder.h         | 141 +--
 contrib/gmm/gmm_dense_lu.h                  | 199 ++--
 contrib/gmm/gmm_dense_matrix_functions.h    | 302 ++++++
 contrib/gmm/gmm_dense_qr.h                  | 399 ++++----
 contrib/gmm/gmm_dense_sylvester.h           |  59 +-
 contrib/gmm/gmm_domain_decomp.h             |  83 +-
 contrib/gmm/gmm_except.h                    | 463 +++++----
 contrib/gmm/gmm_feedback_management.h       | 174 ++++
 contrib/gmm/gmm_inoutput.h                  | 489 +++++-----
 contrib/gmm/gmm_interface.h                 |  83 +-
 contrib/gmm/gmm_interface_bgeot.h           |  59 +-
 contrib/gmm/gmm_iter.h                      | 115 ++-
 contrib/gmm/gmm_iter_solvers.h              |  62 +-
 contrib/gmm/gmm_kernel.h                    |  60 +-
 contrib/gmm/gmm_lapack_interface.h          | 470 +++++----
 contrib/gmm/gmm_least_squares_cg.h          |  59 +-
 contrib/gmm/gmm_matrix.h                    | 599 ++++++------
 contrib/gmm/gmm_modified_gram_schmidt.h     |  76 +-
 contrib/gmm/gmm_opt.h                       | 172 ++--
 contrib/gmm/gmm_precond.h                   |  61 +-
 contrib/gmm/gmm_precond_diagonal.h          |  69 +-
 contrib/gmm/gmm_precond_ildlt.h             | 111 +--
 contrib/gmm/gmm_precond_ildltt.h            | 109 +--
 contrib/gmm/gmm_precond_ilu.h               |  76 +-
 contrib/gmm/gmm_precond_ilut.h              |  94 +-
 contrib/gmm/gmm_precond_ilutp.h             |  71 +-
 contrib/gmm/gmm_precond_mr_approx_inverse.h |  65 +-
 contrib/gmm/gmm_range_basis.h               | 499 ++++++++++
 contrib/gmm/gmm_real_part.h                 | 396 ++++----
 contrib/gmm/gmm_ref.h                       |  63 +-
 contrib/gmm/gmm_scaled.h                    | 249 ++---
 contrib/gmm/gmm_solver_Newton.h             | 137 ---
 contrib/gmm/gmm_solver_Schwarz_additive.h   | 163 +++-
 contrib/gmm/gmm_solver_bfgs.h               |  71 +-
 contrib/gmm/gmm_solver_bicgstab.h           |  64 +-
 contrib/gmm/gmm_solver_cg.h                 | 102 +-
 contrib/gmm/gmm_solver_constrained_cg.h     |  63 +-
 contrib/gmm/gmm_solver_gmres.h              |  68 +-
 contrib/gmm/gmm_solver_idgmres.h            |  59 +-
 contrib/gmm/gmm_solver_qmr.h                |  73 +-
 contrib/gmm/gmm_std.h                       | 267 ++++--
 contrib/gmm/gmm_sub_index.h                 |  93 +-
 contrib/gmm/gmm_sub_matrix.h                |  73 +-
 contrib/gmm/gmm_sub_vector.h                |  74 +-
 contrib/gmm/gmm_superlu_interface.h         |  90 +-
 contrib/gmm/gmm_transposed.h                |  63 +-
 contrib/gmm/gmm_tri_solve.h                 |  91 +-
 contrib/gmm/gmm_vector.h                    | 996 ++++++++++++++++----
 contrib/gmm/gmm_vector_to_matrix.h          |  59 +-
 src/solver/linearSystemCSR.cpp              |   2 +-
 src/solver/linearSystemGmm.h                |   2 +-
 60 files changed, 6325 insertions(+), 4139 deletions(-)
 create mode 100644 contrib/gmm/gmm_arch_config.h
 create mode 100644 contrib/gmm/gmm_dense_matrix_functions.h
 create mode 100644 contrib/gmm/gmm_feedback_management.h
 create mode 100644 contrib/gmm/gmm_range_basis.h
 delete mode 100644 contrib/gmm/gmm_solver_Newton.h

diff --git a/contrib/gmm/gmm.h b/contrib/gmm/gmm.h
index 4aeaa2644f..b7d989a383 100644
--- a/contrib/gmm/gmm.h
+++ b/contrib/gmm/gmm.h
@@ -1,32 +1,33 @@
-// -*- c++ -*- (enables emacs c++ mode)
-//===========================================================================
-//
-// Copyright (C) 2002-2008 Yves Renard
-//
-// This file is a part of GETFEM++
-//
-// Getfem++  is  free software;  you  can  redistribute  it  and/or modify it
-// under  the  terms  of the  GNU  Lesser General Public License as published
-// by  the  Free Software Foundation;  either version 2.1 of the License,  or
-// (at your option) any later version.
-// This program  is  distributed  in  the  hope  that it will be useful,  but
-// WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
-// or  FITNESS  FOR  A PARTICULAR PURPOSE.  See the GNU Lesser General Public
-// License for more details.
-// You  should  have received a copy of the GNU Lesser General Public License
-// along  with  this program;  if not, write to the Free Software Foundation,
-// Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301, USA.
-//
-// As a special exception, you may use this file as part of a free software
-// library without restriction.  Specifically, if other files instantiate
-// templates or use macros or inline functions from this file, or you compile
-// this file and link it with other files to produce an executable, this
-// file does not by itself cause the resulting executable to be covered by
-// the GNU General Public License.  This exception does not however
-// invalidate any other reasons why the executable file might be covered by
-// the GNU General Public License.
-//
-//===========================================================================
+/* -*- c++ -*- (enables emacs c++ mode) */
+/*===========================================================================
+
+ Copyright (C) 2002-2020 Yves Renard
+
+ This file is a part of GetFEM
+
+ GetFEM  is  free software;  you  can  redistribute  it  and/or modify it
+ under  the  terms  of the  GNU  Lesser General Public License as published
+ by  the  Free Software Foundation;  either version 3 of the License,  or
+ (at your option) any later version along with the GCC Runtime Library
+ Exception either version 3.1 or (at your option) any later version.
+ This program  is  distributed  in  the  hope  that it will be useful,  but
+ WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
+ or  FITNESS  FOR  A PARTICULAR PURPOSE.  See the GNU Lesser General Public
+ License and GCC Runtime Library Exception for more details.
+ You  should  have received a copy of the GNU Lesser General Public License
+ along  with  this program;  if not, write to the Free Software Foundation,
+ Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301, USA.
+
+ As a special exception, you  may use  this file  as it is a part of a free
+ software  library  without  restriction.  Specifically,  if   other  files
+ instantiate  templates  or  use macros or inline functions from this file,
+ or  you compile this  file  and  link  it  with other files  to produce an
+ executable, this file  does  not  by itself cause the resulting executable
+ to be covered  by the GNU Lesser General Public License.  This   exception
+ does not  however  invalidate  any  other  reasons why the executable file
+ might be covered by the GNU Lesser General Public License.
+
+===========================================================================*/
 
 /**@file gmm.h
    @author  Yves Renard <Yves.Renard@insa-lyon.fr>
@@ -46,7 +47,7 @@
 
 #include "gmm_lapack_interface.h"
 #include "gmm_superlu_interface.h"
-#include "gmm_MUMPS_interface.h"
+#include "gmm_range_basis.h"
 
 #include "gmm_domain_decomp.h"
 
diff --git a/contrib/gmm/gmm_MUMPS_interface.h b/contrib/gmm/gmm_MUMPS_interface.h
index a7c14013da..3325690e62 100644
--- a/contrib/gmm/gmm_MUMPS_interface.h
+++ b/contrib/gmm/gmm_MUMPS_interface.h
@@ -1,32 +1,33 @@
-// -*- c++ -*- (enables emacs c++ mode)
-//===========================================================================
-//
-// Copyright (C) 2003-2008 Yves Renard
-//
-// This file is a part of GETFEM++
-//
-// Getfem++  is  free software;  you  can  redistribute  it  and/or modify it
-// under  the  terms  of the  GNU  Lesser General Public License as published
-// by  the  Free Software Foundation;  either version 2.1 of the License,  or
-// (at your option) any later version.
-// This program  is  distributed  in  the  hope  that it will be useful,  but
-// WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
-// or  FITNESS  FOR  A PARTICULAR PURPOSE.  See the GNU Lesser General Public
-// License for more details.
-// You  should  have received a copy of the GNU Lesser General Public License
-// along  with  this program;  if not, write to the Free Software Foundation,
-// Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301, USA.
-//
-// As a special exception, you may use this file as part of a free software
-// library without restriction.  Specifically, if other files instantiate
-// templates or use macros or inline functions from this file, or you compile
-// this file and link it with other files to produce an executable, this
-// file does not by itself cause the resulting executable to be covered by
-// the GNU General Public License.  This exception does not however
-// invalidate any other reasons why the executable file might be covered by
-// the GNU General Public License.
-//
-//===========================================================================
+/* -*- c++ -*- (enables emacs c++ mode) */
+/*===========================================================================
+
+ Copyright (C) 2003-2020 Yves Renard, Julien Pommier
+
+ This file is a part of GetFEM
+
+ GetFEM  is  free software;  you  can  redistribute  it  and/or modify it
+ under  the  terms  of the  GNU  Lesser General Public License as published
+ by  the  Free Software Foundation;  either version 3 of the License,  or
+ (at your option) any later version along with the GCC Runtime Library
+ Exception either version 3.1 or (at your option) any later version.
+ This program  is  distributed  in  the  hope  that it will be useful,  but
+ WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
+ or  FITNESS  FOR  A PARTICULAR PURPOSE.  See the GNU Lesser General Public
+ License and GCC Runtime Library Exception for more details.
+ You  should  have received a copy of the GNU Lesser General Public License
+ along  with  this program;  if not, write to the Free Software Foundation,
+ Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301, USA.
+
+ As a special exception, you  may use  this file  as it is a part of a free
+ software  library  without  restriction.  Specifically,  if   other  files
+ instantiate  templates  or  use macros or inline functions from this file,
+ or  you compile this  file  and  link  it  with other files  to produce an
+ executable, this file  does  not  by itself cause the resulting executable
+ to be covered  by the GNU Lesser General Public License.  This   exception
+ does not  however  invalidate  any  other  reasons why the executable file
+ might be covered by the GNU Lesser General Public License.
+
+===========================================================================*/
 
 /**@file gmm_MUMPS_interface.h
    @author Yves Renard <Yves.Renard@insa-lyon.fr>,
@@ -34,7 +35,7 @@
    @date December 8, 2005.
    @brief Interface with MUMPS (LU direct solver for sparse matrices).
 */
-#if defined(GMM_USES_MUMPS)
+#if defined(GMM_USES_MUMPS) || defined(HAVE_DMUMPS_C_H)
 
 #ifndef GMM_MUMPS_INTERFACE_H
 #define GMM_MUMPS_INTERFACE_H
@@ -65,34 +66,44 @@ extern "C" {
 
 namespace gmm {
 
+#define ICNTL(I) icntl[(I)-1]
+#define INFO(I) info[(I)-1]
+#define INFOG(I) infog[(I)-1]
+#define RINFOG(I) rinfog[(I)-1]
+
   template <typename T> struct ij_sparse_matrix {
     std::vector<int> irn;
     std::vector<int> jcn;
-    std::vector<T>        a;
+    std::vector<T> a;
+    bool sym;
     
     template <typename L> void store(const L& l, size_type i) {
        typename linalg_traits<L>::const_iterator it = vect_const_begin(l),
-	 ite = vect_const_end(l);
-       for (; it != ite; ++it)
-	 { irn.push_back(i + 1); jcn.push_back(it.index() + 1); a.push_back(*it); }
+         ite = vect_const_end(l);
+       for (; it != ite; ++it) {
+         int ir = (int)i + 1, jc = (int)it.index() + 1;
+         if (*it != T(0) && (!sym || ir >= jc)) 
+         { irn.push_back(ir); jcn.push_back(jc); a.push_back(*it); }
+       }
     }
 
     template <typename L> void build_from(const L& l, row_major) {
       for (size_type i = 0; i < mat_nrows(l); ++i)
-	store(mat_const_row(l, i), i);
+        store(mat_const_row(l, i), i);
     }
 
     template <typename L> void build_from(const L& l, col_major) {
       for (size_type i = 0; i < mat_ncols(l); ++i)
-	store(mat_const_col(l, i), i);
+        store(mat_const_col(l, i), i);
       irn.swap(jcn);
     }
 
-    template <typename L> ij_sparse_matrix(const L& A) {
+    template <typename L> ij_sparse_matrix(const L& A, bool sym_) {
       size_type nz = nnz(A);
+      sym = sym_;
       irn.reserve(nz); jcn.reserve(nz); a.reserve(nz);
       build_from(A,  typename principal_orientation_type<typename
-	       linalg_traits<L>::sub_orientation>::potype());
+                 linalg_traits<L>::sub_orientation>::potype());
     }
   };
 
@@ -100,7 +111,6 @@ namespace gmm {
   /*   MUMPS solve interface                                               */
   /* ********************************************************************* */
 
-
   template <typename T> struct mumps_interf {};
 
   template <> struct mumps_interf<float> {
@@ -129,20 +139,45 @@ namespace gmm {
   };
 
 
+  template <typename MUMPS_STRUCT>
+  static inline bool mumps_error_check(MUMPS_STRUCT &id) {
+    if (id.INFO(1) < 0) {
+      switch (id.INFO(1)) {
+        case -2:
+          GMM_ASSERT1(false, "Solve with MUMPS failed: NZ = " << id.INFO(2)
+                      << " is out of range");
+        case -6 : case -10 :
+          GMM_WARNING1("Solve with MUMPS failed: matrix is singular");
+          return false;
+        case -9:
+          GMM_ASSERT1(false, "Solve with MUMPS failed: error "
+                      << id.INFO(1) << ", increase ICNTL(14)");
+        case -13 :
+          GMM_ASSERT1(false, "Solve with MUMPS failed: not enough memory");
+        default :
+          GMM_ASSERT1(false, "Solve with MUMPS failed with error "
+                      << id.INFO(1));
+      }
+    }
+    return true;
+  }
+
+
   /** MUMPS solve interface  
    *  Works only with sparse or skyline matrices
    */
   template <typename MAT, typename VECTX, typename VECTB>
-  void MUMPS_solve(const MAT &A, const VECTX &X_, const VECTB &B) {
+  bool MUMPS_solve(const MAT &A, const VECTX &X_, const VECTB &B,
+                   bool sym = false, bool distributed = false) {
     VECTX &X = const_cast<VECTX &>(X_);
 
     typedef typename linalg_traits<MAT>::value_type T;
     typedef typename mumps_interf<T>::value_type MUMPS_T;
-    GMM_ASSERT2(gmm::mat_nrows(A) == gmm::mat_ncols(A), "Non square matrix");
+    GMM_ASSERT2(gmm::mat_nrows(A) == gmm::mat_ncols(A), "Non-square matrix");
   
     std::vector<T> rhs(gmm::vect_size(B)); gmm::copy(B, rhs);
-  
-    ij_sparse_matrix<T> AA(A);
+
+    ij_sparse_matrix<T> AA(A, sym);
   
     const int JOB_INIT = -1;
     const int JOB_END = -2;
@@ -150,64 +185,67 @@ namespace gmm {
 
     typename mumps_interf<T>::MUMPS_STRUC_C id;
 
+    int rank(0);
 #ifdef GMM_USES_MPI
-    int rank;
     MPI_Comm_rank(MPI_COMM_WORLD, &rank);
 #endif
     
     id.job = JOB_INIT;
     id.par = 1;
-    id.sym = 0;
+    id.sym = sym ? 2 : 0;
     id.comm_fortran = USE_COMM_WORLD;
     mumps_interf<T>::mumps_c(id);
     
-#ifdef GMM_USES_MPI
-    if (rank == 0) {
-#endif
-      id.n = gmm::mat_nrows(A);
-      id.nz = AA.irn.size();
-      id.irn = &(AA.irn[0]);
-      id.jcn = &(AA.jcn[0]);
-      id.a = (MUMPS_T*)(&(AA.a[0]));
-      id.rhs = (MUMPS_T*)(&(rhs[0]));
-#ifdef GMM_USES_MPI
+    if (rank == 0 || distributed) {
+      id.n = int(gmm::mat_nrows(A));
+      if (distributed) {
+        id.nz_loc = int(AA.irn.size());
+        id.irn_loc = &(AA.irn[0]);
+        id.jcn_loc = &(AA.jcn[0]);
+        id.a_loc = (MUMPS_T*)(&(AA.a[0]));
+      } else {
+        id.nz = int(AA.irn.size());
+        id.irn = &(AA.irn[0]);
+        id.jcn = &(AA.jcn[0]);
+        id.a = (MUMPS_T*)(&(AA.a[0]));
+      }
+      if (rank == 0)
+        id.rhs = (MUMPS_T*)(&(rhs[0]));
     }
-#endif
 
-#define ICNTL(I) icntl[(I)-1]
-#define INFO(I) info[(I)-1]
-    id.ICNTL(1) = -1; id.ICNTL(2) = -1; id.ICNTL(3) = -1; id.ICNTL(4) = 0;
-    id.job = 6;
-    
-    id.ICNTL(14) += 40; /* small boost to the workspace size as we have encountered some problem
-			   who did not fit in the default settings of mumps.. 
-			   by default, ICNTL(14) = 15 or 20
-		       */
+    id.ICNTL(1) = -1; // output stream for error messages
+    id.ICNTL(2) = -1; // output stream for other messages
+    id.ICNTL(3) = -1; // output stream for global information
+    id.ICNTL(4) = 0;  // verbosity level
+
+    if (distributed)
+      id.ICNTL(5) = 0;  // assembled input matrix (default)
+
+    id.ICNTL(14) += 80; /* small boost to the workspace size as we have encountered some problem
+                           who did not fit in the default settings of mumps.. 
+                           by default, ICNTL(14) = 15 or 20
+                        */
     //cout << "ICNTL(14): " << id.ICNTL(14) << "\n";
 
+    if (distributed)
+      id.ICNTL(18) = 3; // strategy for distributed input matrix
+
+    // id.ICNTL(22) = 1;   /* enables out-of-core support */
+
+    id.job = 6;
     mumps_interf<T>::mumps_c(id);
-    if (id.INFO(1) < 0) {
-      switch (id.INFO(1)) {
-	case -6 : case -10 :
-	  GMM_ASSERT1(false, "Solve with MUMPS failed: matrix is singular");
-	case -13 :
-	  GMM_ASSERT1(false, "Solve with MUMPS failed: not enough memory");
-        case -9:
-	  GMM_ASSERT1(false, "Solve with MUMPS failed: error " << id.INFO(1)
-		      << ", increase ICNTL(14)");
-	default :
-	  GMM_ASSERT1(false, "Solve with MUMPS failed with error "
-		      << id.INFO(1));
-      }
-    }
+    bool ok = mumps_error_check(id);
 
     id.job = JOB_END;
     mumps_interf<T>::mumps_c(id);
 
+#ifdef GMM_USES_MPI
+    MPI_Bcast(&(rhs[0]),id.n,gmm::mpi_type(T()),0,MPI_COMM_WORLD);
+#endif
+
     gmm::copy(rhs, X);
 
-#undef ICNTL
-#undef INFO
+    return ok;
 
   }
 
@@ -217,17 +255,31 @@ namespace gmm {
    *  Works only with sparse or skyline matrices
    */
   template <typename MAT, typename VECTX, typename VECTB>
-  void MUMPS_distributed_matrix_solve(const MAT &A, const VECTX &X_,
-				      const VECTB &B) {
-    VECTX &X = const_cast<VECTX &>(X_);
+  bool MUMPS_distributed_matrix_solve(const MAT &A, const VECTX &X_,
+                                      const VECTB &B, bool sym = false) {
+    return MUMPS_solve(A, X_, B, sym, true);
+  }
 
-    typedef typename linalg_traits<MAT>::value_type T;
+
+
+  template<typename T>
+  inline T real_or_complex(std::complex<T> a) { return a.real(); }
+  template<typename T>
+  inline T real_or_complex(T &a) { return a; }
+
+
+  /** Evaluate matrix determinant with MUMPS  
+   *  Works only with sparse or skyline matrices
+   */
+  template <typename MAT, typename T = typename linalg_traits<MAT>::value_type>
+  T MUMPS_determinant(const MAT &A, int &exponent,
+                      bool sym = false, bool distributed = false) {
+    exponent = 0;
     typedef typename mumps_interf<T>::value_type MUMPS_T;
+    typedef typename number_traits<T>::magnitude_type R;
     GMM_ASSERT2(gmm::mat_nrows(A) == gmm::mat_ncols(A), "Non-square matrix");
   
-    std::vector<T> rhs(gmm::vect_size(B)); gmm::copy(B, rhs);
-  
-    ij_sparse_matrix<T> AA(A);
+    ij_sparse_matrix<T> AA(A, sym);
   
     const int JOB_INIT = -1;
     const int JOB_END = -2;
@@ -235,68 +287,65 @@ namespace gmm {
 
     typename mumps_interf<T>::MUMPS_STRUC_C id;
 
+    int rank(0);
 #ifdef GMM_USES_MPI
-    int rank;
     MPI_Comm_rank(MPI_COMM_WORLD, &rank);
 #endif
     
     id.job = JOB_INIT;
     id.par = 1;
-    id.sym = 0;
+    id.sym = sym ? 2 : 0;
     id.comm_fortran = USE_COMM_WORLD;
     mumps_interf<T>::mumps_c(id);
     
-    id.n = gmm::mat_nrows(A);
-    id.nz_loc = AA.irn.size();
-    id.irn_loc = &(AA.irn[0]);
-    id.jcn_loc = &(AA.jcn[0]);
-    id.a_loc = (MUMPS_T*)(&(AA.a[0]));
-
-#ifdef GMM_USES_MPI
-    if (rank == 0) {
-#endif
-      id.rhs = (MUMPS_T*)(&(rhs[0]));
-#ifdef GMM_USES_MPI
+    if (rank == 0 || distributed) {
+      id.n = int(gmm::mat_nrows(A));
+      if (distributed) {
+        id.nz_loc = int(AA.irn.size());
+        id.irn_loc = &(AA.irn[0]);
+        id.jcn_loc = &(AA.jcn[0]);
+        id.a_loc = (MUMPS_T*)(&(AA.a[0]));
+      } else {
+        id.nz = int(AA.irn.size());
+        id.irn = &(AA.irn[0]);
+        id.jcn = &(AA.jcn[0]);
+        id.a = (MUMPS_T*)(&(AA.a[0]));
+      }
     }
-#endif
 
-#define ICNTL(I) icntl[(I)-1]
-#define INFO(I) info[(I)-1]
-    id.ICNTL(1) = -1; id.ICNTL(2) = 6; // id.ICNTL(2) = -1;
-    id.ICNTL(3) = 6;
-    // id.ICNTL(3) = -1; 
-    id.ICNTL(4) = 2;
-    id.ICNTL(5)=0; id.ICNTL(18)=3;
-    id.job = 6;
+    id.ICNTL(1) = -1; // output stream for error messages
+    id.ICNTL(2) = -1; // output stream for other messages
+    id.ICNTL(3) = -1; // output stream for global information
+    id.ICNTL(4) = 0;  // verbosity level
+
+    if (distributed)
+      id.ICNTL(5) = 0;  // assembled input matrix (default)
+
+//    id.ICNTL(14) += 80; // small boost to the workspace size 
+
+    if (distributed)
+      id.ICNTL(18) = 3; // strategy for distributed input matrix
+
+    id.ICNTL(31) = 1;   // only factorization, no solution to follow
+    id.ICNTL(33) = 1;   // request determinant calculation
+
+    id.job = 4; // abalysis (job=1) + factorization (job=2)
     mumps_interf<T>::mumps_c(id);
-    if (id.INFO(1) < 0) {
-      switch (id.INFO(1)) {
-      case -6 : case -10 :
-	GMM_ASSERT1(false, "Solve with MUMPS failed: matrix is singular");
-      case -13:
-	GMM_ASSERT1(false, "Solve with MUMPS failed: not enough memory");
-      case -9:
-	GMM_ASSERT1(false, "Solve with MUMPS failed: error " << id.INFO(1)
-		    << ", increase ICNTL(14)");
-      default :
-	GMM_ASSERT1(false, "Solve with MUMPS failed with error " <<id.INFO(1));
-      }
-    }
+    mumps_error_check(id);
+
+    T det = real_or_complex(std::complex<R>(id.RINFOG(12),id.RINFOG(13)));
+    exponent = id.INFOG(34);
 
     id.job = JOB_END;
     mumps_interf<T>::mumps_c(id);
-#ifdef GMM_USES_MPI
-    MPI_Bcast(&(rhs[0]),id.n,gmm::mpi_type(T()),0,MPI_COMM_WORLD);
-#endif
-    gmm::copy(rhs, X);
-
-#undef ICNTL
-#undef INFO
 
+    return det;
   }
 
-
-
+#undef ICNTL
+#undef INFO
+#undef INFOG
+#undef RINFOG
 
 }
 
diff --git a/contrib/gmm/gmm_algobase.h b/contrib/gmm/gmm_algobase.h
index 1b72ac217b..b07b6d93ae 100644
--- a/contrib/gmm/gmm_algobase.h
+++ b/contrib/gmm/gmm_algobase.h
@@ -1,32 +1,33 @@
-// -*- c++ -*- (enables emacs c++ mode)
-//===========================================================================
-//
-// Copyright (C) 2000-2008 Yves Renard
-//
-// This file is a part of GETFEM++
-//
-// Getfem++  is  free software;  you  can  redistribute  it  and/or modify it
-// under  the  terms  of the  GNU  Lesser General Public License as published
-// by  the  Free Software Foundation;  either version 2.1 of the License,  or
-// (at your option) any later version.
-// This program  is  distributed  in  the  hope  that it will be useful,  but
-// WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
-// or  FITNESS  FOR  A PARTICULAR PURPOSE.  See the GNU Lesser General Public
-// License for more details.
-// You  should  have received a copy of the GNU Lesser General Public License
-// along  with  this program;  if not, write to the Free Software Foundation,
-// Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301, USA.
-//
-// As a special exception, you may use this file as part of a free software
-// library without restriction.  Specifically, if other files instantiate
-// templates or use macros or inline functions from this file, or you compile
-// this file and link it with other files to produce an executable, this
-// file does not by itself cause the resulting executable to be covered by
-// the GNU General Public License.  This exception does not however
-// invalidate any other reasons why the executable file might be covered by
-// the GNU General Public License.
-//
-//===========================================================================
+/* -*- c++ -*- (enables emacs c++ mode) */
+/*===========================================================================
+
+ Copyright (C) 2000-2020 Yves Renard
+
+ This file is a part of GetFEM
+
+ GetFEM  is  free software;  you  can  redistribute  it  and/or modify it
+ under  the  terms  of the  GNU  Lesser General Public License as published
+ by  the  Free Software Foundation;  either version 3 of the License,  or
+ (at your option) any later version along with the GCC Runtime Library
+ Exception either version 3.1 or (at your option) any later version.
+ This program  is  distributed  in  the  hope  that it will be useful,  but
+ WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
+ or  FITNESS  FOR  A PARTICULAR PURPOSE.  See the GNU Lesser General Public
+ License and GCC Runtime Library Exception for more details.
+ You  should  have received a copy of the GNU Lesser General Public License
+ along  with  this program;  if not, write to the Free Software Foundation,
+ Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301, USA.
+
+ As a special exception, you  may use  this file  as it is a part of a free
+ software  library  without  restriction.  Specifically,  if   other  files
+ instantiate  templates  or  use macros or inline functions from this file,
+ or  you compile this  file  and  link  it  with other files  to produce an
+ executable, this file  does  not  by itself cause the resulting executable
+ to be covered  by the GNU Lesser General Public License.  This   exception
+ does not  however  invalidate  any  other  reasons why the executable file
+ might be covered by the GNU Lesser General Public License.
+
+===========================================================================*/
 
 /** @file gmm_algobase.h 
    @author  Yves Renard <Yves.Renard@insa-lyon.fr>
@@ -48,39 +49,36 @@ namespace gmm {
   /* ********************************************************************* */
   
   template <class T>
-    struct less : public std::binary_function<T, T, int> {
+    struct less {
     inline int operator()(const T& x, const T& y) const
     { return (x < y) ? -1 : ((y < x) ? 1 : 0); }
   };
 
-  template<> struct less<int> : public std::binary_function<int, int, int>
-  { int operator()(int x, int y) const { return x-y; } };
-  template<> struct less<char> : public std::binary_function<char, char, int>
-  { int operator()(char x, char y) const { return int(x-y); } };
-  template<> struct less<short> : public std::binary_function<short,short,int>
-  { int operator()(short x, short y) const { return int(x-y); } };
-  template<> struct less<unsigned char>
-     : public std::binary_function<unsigned char, unsigned char, int> {
+  template<> struct less<int> {
+    int operator()(int x, int y) const { return x-y; } };
+  template<> struct less<char> {
+    int operator()(char x, char y) const { return int(x-y); } };
+  template<> struct less<short> {
+    int operator()(short x, short y) const { return int(x-y); } };
+  template<> struct less<unsigned char> {
     int operator()(unsigned char x, unsigned char y) const
     { return int(x)-int(y); }
   };
   
 
   template <class T>
-    struct greater : public std::binary_function<T, T, int> {
+    struct greater {
     inline int operator()(const T& x, const T& y) const
     { return (y < x) ? -1 : ((x < y) ? 1 : 0); }
   };
 
-  template<> struct greater<int> : public std::binary_function<int, int, int>
-  { int operator()(int x, int y) const { return y-x; } };
-  template<> struct greater<char> : public std::binary_function<char,char,int>
-  { int operator()(char x, char y) const { return int(y-x); } };
-  template<> struct greater<short>
-      : public std::binary_function<short, short, int>
-  { int operator()(short x, short y) const { return int(y-x); } };
-  template<> struct greater<unsigned char>
-    : public std::binary_function<unsigned char, unsigned char, int> {
+  template<> struct greater<int> {
+    int operator()(int x, int y) const { return y-x; } };
+  template<> struct greater<char> {
+    int operator()(char x, char y) const { return int(y-x); } };
+  template<> struct greater<short> {
+    int operator()(short x, short y) const { return int(y-x); } };
+  template<> struct greater<unsigned char> {
     int operator()(unsigned char x, unsigned char y) const
       { return int(y)-int(x); }
   };
@@ -88,7 +86,7 @@ namespace gmm {
   template <typename T> inline T my_abs(T a) { return (a < T(0)) ? T(-a) : a; }
   
   template <class T>
-    struct approx_less : public std::binary_function<T, T, int> { 
+    struct approx_less { 
     double eps;
     inline int operator()(const T &x, const T &y) const
     { if (my_abs(x - y) <= eps) return 0; if (x < y) return -1; return 1; }
@@ -96,7 +94,7 @@ namespace gmm {
   };
 
   template <class T>
-    struct approx_greater : public std::binary_function<T, T, int> { 
+    struct approx_greater { 
     double eps;
     inline int operator()(const T &x, const T &y) const
     { if (my_abs(x - y) <= eps) return 0; if (x > y) return -1; return 1; }
@@ -109,12 +107,13 @@ namespace gmm {
     int i;
     for ( ; b1 != e1 && b2 != e2; ++b1, ++b2)
       if ((i = c(*b1, *b2)) != 0) return i;
-    if (b1 != e1) return 1; if (b2 != e2) return -1; return 0; 
+    if (b1 != e1) return 1;
+    if (b2 != e2) return -1;
+    return 0; 
   }
 
   template<class CONT, class COMP = gmm::less<typename CONT::value_type> >
-    struct lexicographical_less : public std::binary_function<CONT, CONT, int>
-  { 
+    struct lexicographical_less {
     COMP c;
     int operator()(const CONT &x, const CONT &y) const {
       return gmm::lexicographical_compare(x.begin(), x.end(),
@@ -124,8 +123,7 @@ namespace gmm {
   };
 
   template<class CONT, class COMP = gmm::less<typename CONT::value_type> >
-  struct lexicographical_greater
-    : public std::binary_function<CONT, CONT, int> { 
+  struct lexicographical_greater {
     COMP c;
     int operator()(const CONT &x, const CONT &y) const {
       return -gmm::lexicographical_compare(x.begin(), x.end(),
@@ -181,7 +179,7 @@ namespace gmm {
     size_t n = 1;
     typename std::iterator_traits<ITER>::value_type res = *first++;
     while (first != last) { res += *first; ++first; ++n; }
-    res /= n;
+    res /= float(n);
     return res;
   }
 
diff --git a/contrib/gmm/gmm_arch_config.h b/contrib/gmm/gmm_arch_config.h
new file mode 100644
index 0000000000..8d3ce66fb2
--- /dev/null
+++ b/contrib/gmm/gmm_arch_config.h
@@ -0,0 +1,7 @@
+#  ifndef _SRC_GMM_GMM_ARCH_CONFIG_H
+#define _SRC_GMM_GMM_ARCH_CONFIG_H 1
+// enable the following line for OpenMP support
+// #define GMM_HAVE_OPENMP
+//
+/* once: _SRC_GMM_GMM_ARCH_CONFIG_H */
+#endif
